#include"Eleve.h"

//puisque la variable est statique, il faut l'initialiser en dehors de toute fonction :
int Eleve::cpt=0;

//Le constructeur de base :
//il faut utiliser le constructeur de la classe Personne comme a :
Eleve::Eleve(string nom,string prenom,int age,int moy[5]):Personne(nom,prenom,age)
{
	//puisqu'on a cr un lve de plus, il faut incrmenter la valeur du compteur :
	Eleve::cpt++;
	for(int i=0;i<5;i++)
	{
		this->moy[i]=moy[i];
	}
	cout<<"eleve cree"<<endl;
}

//Le destructeur d'un lve :
Eleve::~Eleve()
{
	//il faut mettre  jours le compteur :
	Eleve::cpt--;
	cout<<"eleve detruit"<<endl;
}

//cette fonction calcule la moyenne de l'lve et renvoit le rsultat :
int Eleve::Calculmoyenne()
{
	return (moy[0]+moy[1]+moy[2]+moy[3]+moy[4])/5;
}

//une fonction pour afficher les informations de l'Eleve
//(et fait appel  la fonction affiche de la classe mre...) :
void Eleve::affiche()
{
	cout<<"il y a "<<this->cpt<<"eleves"<<endl;
	Personne::affiche();
	cout<<"la moyenne est de "<<Calculmoyenne()<<endl;
}

//C'est un constructeur qui cr un Eleve sans aucune info :
//Ce constructeur est obligatoire quand on cr un tableau d'lves
//on met donc des valeurs nulles dans les paramtres :
Eleve::Eleve():Personne("","",0)
{
}

//une fonction pour modifier les infos de l'lve
//utile quand on a cr un tableau d'lves, et qu'on veux
//modifier les valeurs d'une case de ce tableau...
//c'est la mme chose que le constructeur, sauf qu'on appelle une autre fonction que
//le constructeur de Personne :
void Eleve::setEleve(string nom,string prenom,int age,int moy[5])
{
	Eleve::cpt++;
	//On ne peux plus utiliser le constructeur de Personne
	//on utilise une autre fonction du mme style :
	Personne::setPersonne(nom,prenom,age);
	for(int i=0;i<5;i++)
	{
		this->moy[i]=moy[i];
	}
}
